routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();

Route::get('/', 'BlogController@index');
Route::get('/posts/{post}', 'BlogController@post');
Route::get('/{categoria}','BlogController@categoria')->name('/');
Route::post('/posts/{post}/comment', 'BlogController@comment')->middleware('auth');

Route::get('/home', 'HomeController@index');

Route::group(['prefix' => 'admin', 'namespace' => 'Admin', 'middleware' => 'auth'], function() {
    Route::resource('/posts', 'PostController');
    Route::delete('/eliminar', 'PostController@eliminar')->name('eliminar');
    Route::delete('/eliminarc', 'CategoryController@eliminar')->name('eliminarc');
    Route::delete('/eliminart', 'TagController@eliminar')->name('eliminart');
    Route::put('/posts/{post}/publish', 'PostController@publish')->middleware('admin');
    Route::resource('/categories', 'CategoryController', ['except' => ['show']]);
    Route::resource('/tags', 'TagController', ['except' => ['show']]);
    Route::resource('/comments', 'CommentController', ['only' => ['index', 'destroy']]);
    Route::resource('/users', 'UserController', ['middleware' => 'admin', 'only' => ['index', 'destroy']]);
});

app/Models/Category.php
<?php

namespace App\Models;

use App\Models\Post;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    protected $fillable = ['name'];

    protected static function boot()
    {
        parent::boot();
        static::deleting(function ($category) {
            $category->posts()->delete();
        });
    }

    public function posts()
    {
        return $this->hasMany(Post::class);
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::withCount('posts')->paginate(10);

        return view('admin.categories.index', compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.categories.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, ['name' => 'required']);

        Category::create(['name' => $request->name]);
        flash()->overlay('Category created successfully');

        return redirect('/admin/categories');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('admin.categories.edit', compact('category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Category $category)
    {
        $this->validate($request, ['name' => 'required']);

        $category->update($request->all());
        flash()->overlay('Category updated successfully');

        return redirect('/admin/categories');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        $category->delete();
        flash()->overlay('Category deleted successfully');

        return redirect('/admin/categories');
    }

     public function eliminar(Request $request)
    {
       // $post = Post::find($id)->delete();
       $category = $request->input('eliminar',[]);
      category::whereIn("id",$category)->delete();
            // $request->all();

        // Post::whereIn('id', $request->input('eliminar'))->delete();


        return back()->with('info', 'Eliminado correctamente');
    }
}

resources/views/admin/categories/_form.blade.php
<div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">

    {!! Form::label('name', 'Nombre de la categoria', ['class' => 'col-md-3 control-label colorm']) !!}

    <div class="col-md-7">
        {!! Form::text('name', null, ['class' => 'form-control p-2', 'required', 'autofocus']) !!}

        <span class="help-block">
            <strong>{{ $errors->first('name') }}</strong>
        </span>
    </div>
</div>

resources/views/admin/categories/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container separacion">
        <div class="row" style="height: 80vh">

            <div class="col-md-12 py-5 d-flex justify-content-center">
            <div class="col-md-10 card" style="height: fit-content;border-radius:35px;box-shadow: 0 .5rem 1rem rgba(0,0,0,.25)!important;">
                    <div class="panel-heading text-center" style="margin-top: 40px;border: none;">
                        <h1 style="color:#572983;font-size: 50px">Nueva Categoria</h1>
                    </div>

                    <div class="panel-body">
                        {!! Form::open(['url' => '/admin/categories', 'class' => 'form-horizontal', 'role' => 'form']) !!}

                            @include('admin.categories._form')

                            <div class="form-group">
                                <div class="col-md-8 col-md-offset-2 text-center">
                                    <button type="submit" class="btn btn-primary btn-lg">
                                        <img src="{{asset('images/enviar.png')}}" width="10px" class="mr-3 mb-1">CREAR
                                    </button>
                                </div>
                            </div>

                        {!! Form::close() !!}
                    </div>
                </div>
            </div>

        </div>
    </div>
@endsection

resources/views/admin/categories/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container separacion">
        <div class="row" style="height: 80vh">

            <div class="col-md-12 py-5 d-flex justify-content-center">
            <div class="col-md-10 card" style="height: fit-content;border-radius:35px;box-shadow: 0 .5rem 1rem rgba(0,0,0,.25)!important;">
                    <div class="panel-heading text-center" style="margin-top: 40px;border: none;">
                        <h1 style="color:#572983;font-size: 50px">Editar Categoria</h1>
                    </div>

                    <div class="panel-body">
                        {!! Form::model($category, ['method' => 'PUT', 'url' => "/admin/categories/{$category->id}", 'class' => 'form-horizontal', 'role' => 'form']) !!}

                            @include('admin.categories._form')

                            <div class="form-group">
                                <div class="col-md-8 col-md-offset-2 text-center">
                                    <button type="submit" class="btn btn-primary btn-lg">
                                        <img src="{{asset('images/guardar.png')}}" width="10px" class="mr-3 mb-1">GUARDAR
                                    </button>
                                </div>
                            </div>

                        {!! Form::close() !!}
                    </div>
                </div>
            </div>

        </div>
    </div>
@endsection

resources/views/admin/categories/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container separacion">
        <div class="row" style="height: 80vh">

            <div class="col-md-12 pt-5">
            <div class="col-md-12 card" style="border-radius:35px;box-shadow: 0 .5rem 1rem rgba(0,0,0,.25)!important;">
                    <div class="col-md-12 panel-heading" style="margin-top: 40px;border: none;">
                        <div class="col-xs-12 col-md-6"><h1 style="color:#572983;font-size: 50px">Categorias</h1></div>
                        <div class="col-xs-12 col-md-6 xs-alin">
                             <form action="{{route('eliminarc')}}" method="post">
                            {{ csrf_field() }}
                             <input type="hidden" name="_method" value="delete">
                            <button style="border:none;background-color:transparent;" type="submit" name="borrar" data-confirm="Esta seguro?" class="pull-right mr-3"><img src="{{asset('images/eliminar.png')}}" width="40px"></button>
                            <a onclick="editarpub()" class="pull-right mr-3"><img src="{{asset('images/editar.png')}}" width="40px"></a>
                            <a href="{{ url('admin/categories/create') }}" class="pull-right mr-3"><img src="{{asset('images/crear.png')}}" width="40px"></a>
                        </div>
                    </div>

                    <div class="col-md-12 panel-body">
                        <table class="col-md-12 table">
                            <thead>
                                <tr>
                                    <th>Nombre de la categoria</th>
                                    <th>No. de entradas</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @forelse ($categories as $category)
                                    <tr>
                                        <td>{{ $category->name }}</td>
                                        <td>{{ $category->posts_count }}</td>
                                        <td>
                                            <input onclick="idpublicacion({{ $category->id }})" type="radio" id="action" name="eliminar[]" value="{{ $category->id }}">
                                            {{-- <a href="{{ url("/admin/categories/{$category->id}/edit") }}" class="btn btn-xs btn-info">Editar</a>
                                            <a href="{{ url("/admin/categories/{$category->id}") }}" data-method="DELETE" data-token="{{ csrf_token() }}" data-confirm="Estas seguro?" class="btn btn-xs btn-danger">Eliminar</a> --}}
                                        </td>
                                    </tr>
                                @empty
                                    <tr>
                                        <td colspan="2">No hay categorías</td>
                                    </tr>
                                @endforelse
                            </tbody>
                        </table>

                        {!! $categories->links() !!}

                    </div>
                </div>
            </div>

        </div>
    </div>

     <script type="text/javascript">

        var idpost= "";
        function idpublicacion(id){
            idpost = id;
        }
        function editarpub(){
            window.location.href="http://holox.guru/blog/public/admin/categories/"+idpost+"/edit";
        }
    </script>
@endsection